/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2023.02.01
;  *       @˾/            : SINOMCU.COM-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2022 ΢ Ȩ.
;  *----------------------ժҪ---------------------------------
;  * ʼUART1                                  
******************************************************************************/

#include "User_Def.h"

/************************************************
;  *    @Function Name       : UART1_Init,baud used timer2
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_Init(uint32_t uart_baud) {
  uint16_t xdata baud_rate_cacl=0; 
  SET_UART1EN();                       /*ʹUART1 */

  Uart1_Mode_Set(UART_MODE_01);        /*ʽ1,8bit */ 
  Uart1_REN_set();                     /* */

  baud_rate_cacl =  (65536 - FSYS_CLOCK/16/uart_baud);    
  UART1_BGR_En();                      /*ʹܲʷ*/
  BRGL=(uint8_t)(baud_rate_cacl);
  BRGH=(uint8_t)(baud_rate_cacl >>8);
 
  //UART1_INTR_En();                   /*UART1ж*/
}

/************************************************
;  *    @Function Name       : putchar
;  *    @Description         : ضprintfUART
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
char putchar(char tx_data) {
#if(defined(EN_PRINT_UART) && EN_PRINT_UART) 
  SBUF_1 = tx_data;                    /*дݵUARTݼĴ*/
  while (!Read_Uart1_TI()) { ;}        /*ȴǰݷ*/
  Uart1_TI_clear();
#endif
  return tx_data;
}

/************************************************
;  *    @Function Name       : UART1_ISR
;  *    @Description         : UART1жϷ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void UART1_ISR(void) interrupt UART1_IRQn {
  if(Read_Uart1_RI()) {
    Uart1_RI_clear();
  }
  if(Read_Uart1_TI()) {
    Uart1_TI_clear();
  }
}
/**************************** end of file *********************************************/
